BIO_S_SOCKET(3SSL)

NAME
BIO_s_socket, BIO_new_socket, BIO_set_send_flags - socket BIO

SYNOPSIS
 #include <openssl/bio.h>

 const BIO_METHOD *BIO_s_socket(void);

 BIO *BIO_new_socket(int sock, int close_flag);

 long BIO_set_send_flags(BIO *b, int flags);

DESCRIPTION
BIO_s_socket() returns the socket BIO method. This is a wrapper round the platform's socket routines.

BIO_read_ex() and BIO_write_ex() read or write the underlying socket. BIO_puts() is supported but BIO_gets() is not.

If the close flag is set then the socket is shut down and closed when the BIO is freed.

BIO_new_socket() returns a socket BIO using sock and close_flag.

BIO_set_send_flags() sets flags passed to send(), sendto() and sendmsg(). The set of available flags is platform-dependent. The main intention is to allow setting the MSG_NOSIGNAL flag to avoid a crash on receiving the SIGPIPE signal.

NOTES
Socket BIOs also support any relevant functionality of file descriptor BIOs.

The reason for having separate file descriptor and socket BIOs is that on some platforms sockets are not file descriptors and use distinct I/O routines, Windows is one such platform. Any code mixing the two will not work on all platforms.

RETURN VALUES
BIO_s_socket() returns the socket BIO method.

BIO_new_socket() returns the newly allocated BIO or NULL is an error occurred.

BIO_set_send_flags() returns 1 on success, 0 on errors.

HISTORY
BIO_set_send_flags() was added in OpenSSL 4.0.

COPYRIGHT
Copyright 2000-2026 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at <https://www.openssl.org/source/license.html>.